%function h = channel_reflections(filename,N)

% Load the parameters
N=1;
load('back_par_indoor.mat');

% Get arrival times and convert to bin times
Cndx = get_arrival_times(T1min,T1max,Wa,Wb,Tmax)
Cndx = round(Cndx/Binwidth); %gjr tidspunktet om til sample verdier, og runder av til nrmeste bin

% Get cluster magnitudes
%[Cmag] = get_clusters(Cndx,G0,Gsig,Gdecay*Binwidth);
[Cmag] = get_clusters(Cndx,0,Gsig,Gdecay*Binwidth);



%
%Cmag er en vektor med tilhrende verdier for sampletidspunktene gitt i Cndx
% Add deterministic clusters
if(strcmp(rxpos,'side') | strcmp(rxpos,'back'))
    %CDmag = CDmu + CDstd.*randn(1,length(CDstd));
    CDmag = CDmu - G0 + CDstd.*randn(1,length(CDstd)); %CDmu-G0=my1 og my2
    Cndx(end+1:end+length(CDndx)) = CDndx; %legger til tidspunkt i sample for veggkomponent
    Cmag(end+1:end+length(CDndx)) = CDmag; %legger til cluster fra veggkomponenter i slutten av clustertidspunk
end

% Create Average Power Delay Profile
APDP = get_MPCs(Cndx,Cmag,rmu,rsig,Mdecay*Binwidth,chanlen/Binwidth); 
%Mdecay*Binwidth=dempning per sample
%chanlen/Binwidth=kanales lengde i samples                                                                                        

% Get rid of places with no energy
APDP(find(APDP == 0)) = -100;

% Apply large scale pathloss and fading.
Gtot = Gtotmu + Gtotsig*randn;
APDP = APDP - 10*log10(sum(10.^(APDP/10))) + Gtot;

% Add small scale fading (fixed log)
h = logmu + logsig.*randn(N,length(APDP)) + repmat(APDP,N,1);
%h = repmat(APDP,N,1);

% Add small scale fading (variable log)
%lm = logmu + logmu_sig*randn(1,length(APDP));
%ls = logsig+ logsig_sig*randn(1,length(APDP));
%h = repmat(lm,N,1) + repmat(ls,N,1).*randn(N,length(APDP)) + repmat(APDP,N,1);

% Add small scale fading (variable, correlated log)
%C = [0.1287   -0.1635 ;-0.1635    0.2459];
%x = randn(length(APDP),2);
%y=x*(chol(C))+repmat([logmu logsig],length(APDP),1);
%lm = y(:,1).';ls = y(:,2).';
%h = repmat(lm,N,1) + repmat(ls,N,1).*randn(N,length(APDP)) + repmat(APDP,N,1);

% Add small scale fading (fixed gamma)
%lm = 1.5;
%h = 10*log10(gamrnd(lm,1/lm,N,size(APDP,2))) + repmat(APDP,N,1);

% Add small scale fading (variable gamma)
%for k = 1:length(APDP)
    %m = max(1.5 + 0.5*randn,0.5);
%    m = max(1.6 + 0.7*randn,0.5);
%    h(:,k) = 10*log10(gamrnd(m,1/m,N,1)) + APDP(k);
%end

% Convert to linear scale
h = 10.^(h/10);

% *** GET ARRIVAL TIMES ***
% function Cndx = get_arrival_times(T1min,T1max,a,b,Tmax)
% 
% % Get arrival of first component
% % UNIFORM DISTRIBUTION for first component:
% %ndx1 = rand*(T1max-T1min)+T1min;
% % first component is not treated specially:
% ndx1 = 1;
% 
% % Get inter-arrival times
% ndx = wblrnd(a,b,1,100);
% 
% %Create index of all arrival times
% Cndx = cumsum([ndx1 ndx]);Cndx = Cndx(2:end);
% Cndx = Cndx(find(Cndx < Tmax));
% %keyboard;
% 
% % *** GET MAGNITUDE OF CLUSTERS ***
% function Cmag = get_clusters(Cndx,G0,Gsig,decay)
% 
% % Get mean pathloss at each place
% Cmag = polyval([decay G0],Cndx);
% 
% % Add normal distribution around pathloss
% Cmag = Cmag + Gsig*randn(1,length(Cndx));
% 
% % *** GET MULTIPATH COMPONENTS ***
% function h = get_MPCs(Cndx,Cmag,rmu,rsig,Mdecay,chanlen)
% 
% h = zeros(1,chanlen);
% for k = 1:length(Cndx)
%     newC = zeros(1,chanlen);
%     newC(Cndx(k)) = Cmag(k);newC(Cndx(k));
%     start = min(Cndx(k)+1,chanlen);stop = chanlen;
%     newC(start:stop) = Cmag(k) - (rmu + rsig*randn) - [0:(stop-start)]*Mdecay;
%     h(start-1:stop) = h(start-1:stop) + 10.^(newC(start-1:stop)/10);
% end
% h(find(h~=0)) = 10*log10(h(find(h~=0)));