
function [output,noise_real,noise_complex,SNRdB] = stoy_AWGN_ny(input,numpulses,Pow,fb,Ts);

%Denne delen korregrer bare for noe tap av energi ved filtrering
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
VarNo=5.0119e-012 %variansen, Var=tilsvarende effekten til stoyet p -83dBm

Pow2=(10^-3)*10^(Pow/10); %liner verdi av gjennomsnittlig sendereffekten

SNR=Pow2/VarNo; %Onsket SNR fr kanal. SNR fr filtrering nedkonvertering


Ex = (1/numpulses)*sum(abs(input).^2)*(1/(fb*10^9));  % measured energy per
Px= Ex/Ts; %Gjennomsnittlig utsendt effekt, tilsvarende Pow %

VarNo2=Px/SNR;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
                                   % Unilateral spectral
                                   % density
nstdv = sqrt(VarNo2);               % Standard deviation for
                                   % the noise
noise_real = nstdv.* randn(1,length(input));
noise_complex= noise_real.*exp(i*2*pi*rand(size(noise_real)));
output = noise_complex + input;

SNRdB=10*log10(SNR);
                                   
                                   

