
%
% 'fc' is the sampling frequency
% 'Tm' is the pulse duration
% 'tau' is the shaping parameter
%
% Programmed by Guerino Giancola
%Upgraded Howard!

function [w0]= waveform_all_order(fc,Tm,tau,order);

%fc=900e9;
%Tm=0.5e-9;
%tau=0.25e-9;
%orden=2

% ------------------------------------
% Step One - Pulse waveform generation
% ------------------------------------

dt = 1 / fc;            % reference sampling period
OVER = floor(Tm/dt);    % number of samples representing
                        % the pulse

e = mod(OVER,2);
kbk = floor(OVER/2);
tmp = linspace(dt,Tm/2,kbk);



s0= cp0702_analytical_waveforms(0,order,tau);

for k=1:length(tmp)
    
    s(k)= cp0702_analytical_waveforms(tmp(k),order,tau);
    sodde(k)= cp0702_analytical_waveforms(-tmp(k),order,tau);
end

    


if e                % OVER is odd
    for k=1:length(s)
        y(kbk+1)=s0;  %er nok s(0)
        
        y(kbk+1+k)=s(k);
        y(kbk+1-k)=sodde(k);
    end
else                % OVER is even
    for k=1:length(s)
        
        y(kbk+k)=s(k);
        y(kbk+1-k)=sodde(k);
    end
end

y2=y/6.8699e+157;
y=y2;

E = sum((y.^2).*dt);     % pulse energy
w0 = y ./ (E^0.5);       % energy normalization

